/*************************************************
	Program	: Main.prg
	Function: Control of daily commitments
	Author	: Luis Vsquez P.
	Fecha	: October 20, 2015 
	Compiler: Harbour
	Library : HMG 3.4.2
*************************************************/
#include <hmg.ch>
*-----------------------------------------------------------------
procedure Main

	REQUEST DBFCDX, DBFFPT
	RDDSETDEFAULT('DBFCDX')
	SET LANGUAGE TO SPANISH
	SET CODEPAGE TO SPANISH
	SET NAVIGATION EXTENDED
	SET DELETE ON
	SET CENTURY ON
	SET DATE BRITISH

	abrir_tablas()

	Load Window Main
	Main.Center	
	DEFINE TIMER Timer_1 OF Main INTERVAL 1000 ACTION ( RELEASE MEMORY )
	Main.Activate
Return
*-----------------------------------------------------------------
static procedure button_click(n)
	do case
		case n = 3
			borrar_agenda()
		case n = 4
			imprimir_agenda()
		Otherwise
			edicion_agenda()	
	end case
return
*-----------------------------------------------------------------
static procedure edicion_agenda
	local cNombre := ""
	agenda->( Ordsetfocus( 1 ) )
	agenda->( dbseek( val( main.grid_1.cell( main.grid_1.value, 1 ) ) )	)
	load window edicion
	edicion.title			:= 'Edit - '+dtoc( main.datepicker_1.value )+" "+main.grid_1.cell( main.grid_1.value, 2 )
	edicion.text_1.Value	:= agenda->titulo
	edicion.text_2.Value	:= agenda->contacto
	edicion.edit_1.Value	:= agenda->descri
	edicion.center
	edicion.activate
return
*-----------------------------------------------------------------
static procedure borrar_agenda
	if val( main.grid_1.cell( main.grid_1.value, 1 ) ) > 0 
		if msgyesno('You want to delete this record?'+hb_osnewline()+alltrim(main.grid_1.cell( main.grid_1.value, 3 )),'Confirm')	
			agenda->( Ordsetfocus( 1 ) )
			agenda->( dbseek( val( main.grid_1.cell( main.grid_1.value, 1 ) ) )	)
			if agenda->( found() )
				do while agenda->( ! rlock() ); enddo
				agenda->( dbdelete() )
				agenda->( dbunlock() )
				main.grid_1.cell( main.grid_1.value, 1 ) := "0"
				main.grid_1.cell( main.grid_1.value, 3 ) := ""
				main.grid_1.Setfocus
			endif
		endif
	endif
return
*-----------------------------------------------------------------
static procedure imprimir_agenda
	msginfo('Not ready')
return
*-----------------------------------------------------------------
static procedure grabar_agenda
	agenda->( Ordsetfocus( 1 ) )
	agenda->( dbseek( val( main.grid_1.cell( main.grid_1.value, 1 ) ) )	)
	
	do while agenda->( ! Rlock() ); enddo
	
	if agenda->( eof() )
		agenda->( Dbappend() )
	endif
	agenda->fecha		:= dtos( main.datepicker_1.value )
	agenda->hora		:= main.grid_1.cell( main.grid_1.value, 2 )
	agenda->titulo		:= edicion.text_1.Value
	agenda->contacto	:= edicion.text_2.Value
	agenda->descri		:= edicion.edit_1.value
	
	Main.Grid_1.Cell( Main.Grid_1.Value, 1 )	:= str(agenda->id)
	Main.Grid_1.Cell( Main.Grid_1.Value, 3 )	:= edicion.text_1.value
	
	agenda->( dbunlock() )
	
	edicion.release
return
*-----------------------------------------------------------------
static procedure carga_agenda
	Local cFecha	:= dtos( Main.Datepicker_1.Value )	
	agenda->( ordsetfocus( 2 ) )
	for i= 1 to Main.Grid_1.Itemcount
		do events
		Main.Grid_1.Cell( i, 1 ) := "0"
		Main.Grid_1.Cell( i, 3 ) := ""
		agenda->( dbseek( cFecha + Main.Grid_1.Cell( i, 2 ) ) )	
		if agenda->( found() )	
			Main.Grid_1.Cell( i, 1 ) := str( agenda->id )
			Main.Grid_1.Cell( i, 3 ) := agenda->titulo
		endif
	Next		
return
*-----------------------------------------------------------------
static procedure abrir_tablas
	Local 	aAgenda		:= {{'ID','+',10,0},{'FECHA','C',8,0},{'HORA','C',5,0},{'TITULO','C',50,0}, {'CONTACTO','C',80,0},{'DESCRI','C',300,0}}
	Local	cAgenda		:= 'agenda'
	
	if !file( cAgenda+'.dbf' )
		dbcreate( cAgenda+'.dbf', aAgenda )
	endif
	
	if !file( cAgenda+'.cdx' )
		use ( cAgenda+'.dbf' )
		index on id tag 'id'
		index on fecha+hora tag 'fecha' 
		use
	endif	
	
	dbusearea( .t.,'DBFCDX', cAgenda+'.dbf', 'agenda', .T. )
	dbsetindex( cAgenda+'.cdx' )
	agenda->( ordsetfocus( 2 ) )	
Return 
*-----------------------------------------------------------------
static procedure pinta_horario
	local nHora	:= 7
	Main.Grid_1.DeleteAllitems    		
	while nHora <> 24		
		main.grid_1.additem({'0', strzero( nHora, 2, 0 )+":00",""})
		main.grid_1.additem({'0', strzero( nHora, 2, 0 )+":30",""})
		nHora ++		
	end
return
*-----------------------------------------------------------------
static procedure ajustar
	local nAncho	:= main.button_5.width
	main.grid_1.width	:= main.width - ( main.grid_1.col + 25 )
	main.grid_1.height	:= main.height- ( main.grid_1.row + 70 )
	main.button_5.col	:= main.grid_1.width - nAncho
	main.button_4.col	:= main.button_5.col - nAncho
	main.button_3.col	:= main.button_4.col - nAncho
	main.button_1.Col	:= main.button_3.col - nAncho
return
*-----------------------------------------------------------------
static procedure buscar
	Load Window buscar
	buscar.center
	buscar.activate
return
*-----------------------------------------------------------------
static procedure buscar_registro
	local cTexto:= Upper( Alltrim( buscar.text_1.Value ) )
	local i		:= 0
	if Len( cTexto ) > 0
		buscar.grid_1.deleteallitems		
		agenda->( Ordsetfocus(1) )
		agenda->( dbgotop() )
		buscar.progressbar_1.rangemin	:= 1
		buscar.progressbar_1.rangemax	:= agenda->( reccount() )
		do while agenda->( ! eof() ) .and. .t.
			do events
			buscar.progressbar_1.value	:= ++ i
			if Rat( cTexto, Upper( agenda->titulo ) ) != 0
				buscar.grid_1.additem({	str( agenda->id )			,;
										dtoc( stod(agenda->fecha) )	,;
										agenda->hora				,;
										agenda->titulo				,;
										agenda->descri 				})
			endif	
			agenda->( dbskip() )
		enddo
	endif
return
*-----------------------------------------------------------------
*-----------------------------------------------------------------

